import { world, system } from "@minecraft/server";
    
function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('pmc_weapon_darkness_scythe:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function scythe"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_weapon_entity_killer:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function strength"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); e.source.runCommand("function strength"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_weapon_knife:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_weapon_jeffres_knife:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_food_rottenboiledflesh:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:nausea", 200, {amplifier: 1});
e.source.addEffect("minecraft:poison", 60, {amplifier: 1});
e.source.addEffect("minecraft:speed", 400, {amplifier: 1});
  
},

  onUse: e => {
  e.source.runCommand("function Boiled_flesh");
},

});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_weapon_siren:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function siren"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function siren"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_food_rottenfermentedflesh:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:nausea", 200, {amplifier: 1});
e.source.addEffect("minecraft:poison", 120, {amplifier: 1});
e.source.addEffect("minecraft:resistance", 340, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_food_crawlvines:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:nausea", 180, {amplifier: 1});
e.source.addEffect("minecraft:poison", 60, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_food_crawlflesh:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:nausea", 400, {amplifier: 1});
e.source.addEffect("minecraft:poison", 160, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_food_elderflesh:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:invisibility", 160, {amplifier: 1});
e.source.addEffect("minecraft:poison", 40, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_food_cooked_elderflesh:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:invisibility", 200, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_food_crawlsandwich:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:nausea", 160, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pmc_food_growth:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:nausea", 180, {amplifier: 1});
e.source.addEffect("minecraft:poison", 100, {amplifier: 1});
  
},

  
});
 });
